import router from './router'
import store from './store'
import { Message } from 'element-ui'
import NProgress from 'nprogress'
import 'nprogress/nprogress.css'
import { getToken } from '@/utils/auth'

NProgress.configure({ showSpinner: false })

const whiteList = ['/login', '/auth-redirect', '/bind', '/register', '/captchaUserRegister', '/callback', '/tl', '/buy/return', '/retrieve']

router.beforeEach((to, from, next) => {
  // console.log('getToken---',getToken())
  NProgress.start()
  if (getToken()) {
    /* has token*/
    // console.log('用户信息token---',getToken(),to)
    if (to.path === '/login') {
      next({ path: '/' })
      NProgress.done()
    } else if (to.path === '/register') {
      next({ path: '/' })
      NProgress.done()
    } else {
      if (store.getters.roles.length === 0) {
        // console.log('store.getters---',store.getters,store.getters.token)
        if(store.getters.token!=''||!store.getters.token){
          // 判断当前用户是否已拉取完user_info信息
          store.dispatch('GetInfo').then((res) => {
            // console.log('用户信息路由---',res)
            if(res.code==200){
  
              store.dispatch('GenerateRoutes').then(accessRoutes => {
                // 根据roles权限生成可访问的路由表
                router.addRoutes(accessRoutes) // 动态添加可访问路由表
                next({ ...to, replace: true }) // hack方法 确保addRoutes已完成
              })
            }else{
             
            }
          }).catch(err => {
              store.dispatch('LogOut').then(() => {
                Message.error(err.message)
                next({ path: '/' })
                // location.href = '/index';
              })
            })
        }else{
          console.log('token消失')
          next()
        }
      } else {
        next()
      }
    }
  } else {
    // 没有token
    if (whiteList.indexOf(to.path) !== -1) {
      // 在免登录白名单，直接进入
      next()
    } else {
      next(`/login?redirect=${to.fullPath}`) // 否则全部重定向到登录页
      NProgress.done()
    }
  }
})

router.afterEach(() => {
  NProgress.done()
})
